var db = null;

var app = angular.module('geotraffic', [
  'ionic',
  'ionic.service.core',
  'ionic.service.analytics',
  'ngAnimate',
  'geotraffic.production',
  'geotraffic.controllers',
  'geotraffic.services',
  'geotraffic.filters',
  'navigation.controllers',
  //'geoLokiDB.factories',
  'angular-loading-bar',
  'ngCordova',
  'ionic-audio',
  'ngStorage',
  'ngMessages',
  //'angularSoundManager',
  //'lokijs'
  'ngResource',
  'angularSpinner',
  'ngIOS9UIWebViewPatch',
  'ngMap'

]);
//local and session config

app.config([
  '$localStorageProvider',
  function ($localStorageProvider)
    {
      $localStorageProvider.setKeyPrefix('geo-');
    }
]);

//digest loop increase -- SHOULD NOT BE USED
//.config([
//  '$rootScopeProvider',
//  function ($rootScopeProvider)
//    {
//      $rootScopeProvider.digestTtl(200);
//    }
//]);

app.run(function ($ionicPlatform, $ionicAnalytics, $state, $cordovaSQLite, $localStorage, $http, geoAPI)
{
  var userData = $localStorage;
  //UserStorageService.initDB();
  $ionicPlatform.ready(function ()
  {
    $ionicAnalytics.register();
    userData.currentLocation = false;


    if (window.cordova && window.cordova.plugins.Keyboard)
      {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
        cordova.plugins.Keyboard.disableScroll(true);

      }
    if(window.cordova && $ionicPlatform.isAndroid)
      {
        var posOptions = {
          enableHighAccuracy: true,
          timeout: 30000,
          maximumAge: 0
        };
        $cordovaGeolocation.getCurrentPosition(posOptions).then(function (position)
        {
          var myLatlng = new google.maps.LatLng(lat, long);
          var lat = position.coords.latitude;
          var lng = position.coords.longitude;

          if (lat && lng)
            {
              userData.currentLocation = {
                latitude: lat,
                longitude: lng
              };
            }

          $http({
            method: 'get',
            crossDomain: true,
            url: geoAPI.findMarketEndpoint + lat + "/" + lng,
            contentType: 'application/json;charset=UTF-8',
            dataType: 'text'
          })
            .success(function (resp)
            {
              console.info('location found', resp);
              if (!userData.marketId)
                userData.marketId = resp;
            })
            .error(function (resp)
            {
              console.warn('location not found', resp);
            });

        });
      }else navigator.geolocation.getCurrentPosition(showPosition);

    if (window.StatusBar)
      {
        // org.apache.cordova.statusbar required
        //StatusBar.styleDefault();
        StatusBar.style(1); //Light
        //StatusBar.style(2); //Black, translucent
        //StatusBar.style(3); //Black, opaque
      }
  });
  //console.log('userdata', userData);
  //var userGeoLocation = false;
  //$cordovaGeolocation.getCurrentPosition().then(function (position)
  //{
  //  console.log('showPosition hit run 1', position);
  //  if(position)
  //    {
  //      var lat = position.coords.latitude;
  //      var lng = position.coords.longitude;
  //      showPosition(lat,lng);
  //    }else console.log('Location error');
  //
  //});

  function showPosition(position)
    {
      var lat = position.coords.latitude;
      var lng = position.coords.longitude;

      if (lat && lng)
        {
          userData.currentLocation = {
            latitude: lat,
            longitude: lng
          };
        }

      $http({
        method: 'get',
        crossDomain: true,
        url: geoAPI.findMarketEndpoint + lat + "/" + lng,
        contentType: 'application/json;charset=UTF-8',
        dataType: 'text'
      })
        .success(function (resp)
        {
          console.info('Location Found. Nearest Market: ', resp);
          if (!userData.marketId)
            userData.marketId = resp;
        })
        .error(function (resp)
        {
          console.warn('Location Not Found', resp);
        });
    }

  //shows tutorial splash page or default market
  if (userData.splashComplete)
    {
      //console.log('run state',userData.marketId);
      $state.go('app.defaultMarket', {marketId: userData.marketId});
    } else $state.go('app.splash');


});

//Currently Unused
app.factory('DataStore', function ()
{
  var savedData = {};

  function set(data)
    {
      savedData = data;
    }

  function get()
    {
      return savedData;
    }

  return {
    set: set,
    get: get
  };
});
app.directive('backButton', [
  '$window', function ($window)
    {
      return {
        restrict: 'A',
        link: function (scope, elem)
          {
            elem.bind('click', function ()
            {
              $window.history.back();
            });
          }
      };
    }
]);


angular.module('ngIOS9UIWebViewPatch', ['ng']).config([
  '$provide', function ($provide)
    {
      'use strict';

      $provide.decorator('$browser', [
        '$delegate', '$window', function ($delegate, $window)
          {

            if (isIOS9UIWebView($window.navigator.userAgent))
              {
                return applyIOS9Shim($delegate);
              }

            return $delegate;

            function isIOS9UIWebView(userAgent)
              {
                return /(iPhone|iPad|iPod).* OS 9_\d/.test(userAgent) && !/Version\/9\./.test(userAgent);
              }

            function applyIOS9Shim(browser)
              {
                var pendingLocationUrl = null;
                var originalUrlFn = browser.url;

                browser.url = function ()
                  {
                    if (arguments.length)
                      {
                        pendingLocationUrl = arguments[0];
                        return originalUrlFn.apply(browser, arguments);
                      }

                    return pendingLocationUrl || originalUrlFn.apply(browser, arguments);
                  };

                window.addEventListener('popstate', clearPendingLocationUrl, false);
                window.addEventListener('hashchange', clearPendingLocationUrl, false);

                function clearPendingLocationUrl()
                  {
                    pendingLocationUrl = null;
                  }

                return browser;
              }
          }
      ]);
    }
]);
