//'use strict';

var con = angular.module('geotraffic.controllers', []);

con.controller('AuthController', function ($scope, $ionicModal, $timeout, $localStorage, $state, $ionicHistory,
                                           $sessionStorage, Personalize, $cordovaDevice, $ionicPopup, $log, $window,
                                           geoAPI, Markets, $ionicLoading)
{

  // With the new view caching in Ionic, Controllers are only called
  // when they are recreated or on app start, instead of every page change.
  // To listen for when this page is active (for example, to refresh data),
  // listen for the $ionicView.enter event:
  //$scope.$on('$ionicView.enter', function(e) {
  //});


  //console.log('loc', $scope.location);
  //Device ID
  try
    {
      var uuid = $cordovaDevice.getUUID();
      $log.info('uuid', uuid);
    }
  catch (err)
    {
      uuid = "test";
      $log.warn(err.message);
    }
  //$scope.$on('$stateChangeStart',
  //  function (event, toState, toParams, fromState, fromParams)
  //  {
  //    $ionicLoading.show();
  //  });

  $scope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams)
  {
    //$scope.state = toState.name;
    (toState.name === 'app.defaultMarket' || toState.name === 'app.market') ? $scope.state = true :
      $scope.state = false;
    //$timeout(function ()
    //{
    //  $ionicLoading.hide()
    //}, 1000);
  });

  $ionicHistory.nextViewOptions({
    disableBack: true
  });

  $scope.whiteLabel = geoAPI.whiteLabel;
  $scope.version = geoAPI.version;
  $scope.loginData = {};
  $scope.userData = $localStorage;
  //$log.info('userdata', $scope.userData);

  //Dialog for messages
  $scope.showAlert = function (resp)
    {
      var alertPopup = $ionicPopup.alert({
        title: 'Alert!',
        template: resp
      });
      alertPopup.then(function (res)
      {
        console.log('alert response', res);
      });
      $timeout(function ()
      {
        alertPopup.close(); //close the popup after 3 seconds for some reason
      }, 3000);
    };


// Create the login modal that we will use later
  $ionicModal.fromTemplateUrl('templates/login.html', {
    scope: $scope
  }).then(function (modal)
  {
    $scope.modal = modal;
  });

  $ionicModal.fromTemplateUrl('templates/register.html', {
    scope: $scope
  }).then(function (modal)
  {
    $scope.registerModal = modal;
  });

  $ionicModal.fromTemplateUrl('templates/pwdRecovery.html', {
    scope: $scope
  }).then(function (modal)
  {
    $scope.recoveryModal = modal;
  });

// Triggered in the login modal to close it
  $scope.closeLogin = function ()
    {
      $scope.modal.hide();
    };

  $scope.closeRegister = function ()
    {
      $scope.registerModal.hide();
    };

  $scope.closeRecovery = function ()
    {
      $scope.recoveryModal.hide();
    };

// Open the login modal
  $scope.login = function ()
    {
      $scope.modal.show();
    };

  $scope.logout = function ()
    {
      var confirmLogoutPopup = $ionicPopup.confirm({
        title: 'Logging Out',
        template: 'Are you sure?'
      });
      confirmLogoutPopup.then(function (res)
      {
        if (res)
          {
            $localStorage.$reset();
            $timeout(function ()
            {
              $state.go('app.markets');
              $window.location.reload(true);
            }, 500);
          } else
          {
            console.log('You are not sure');
          }
      });
    };

//Open register modal
  $scope.register = function ()
    {
      $scope.registerModal.show();
    };

//Open recovery modal
  $scope.recovery = function ()
    {
      $scope.recoveryModal.show();
    };

// Perform the login action when the user submits the login form
  $scope.setUserData = function ()
    {
      Personalize.syncUserData($scope.userData).then(function (resp)
      {
        $log.info('sync complete', resp);
      })
    };
  $scope.getUserData = function ()
    {
      Personalize.getUserData($scope.userData).then(function (resp)
      {
        $scope.userData.uId = resp[0].id;
        $scope.userData.lowestRoadCondition = resp[0].lowestRoadCondition;
        $scope.userData.myReportList = resp[0].roadList;
        $scope.userData.marketId = resp[0].marketId;

        $log.info('resp', resp[0]);
      })
    };

  $scope.doLogin = function (valid)
    {
      console.log('Doing login', $scope.loginData);

      if (valid)
        {
          Personalize.personalizeLogin($scope.loginData).then(function (resp)
          {
            $scope.userData.token = resp.token;
            $scope.userData.isAuthenticated = true;
            //$log.info('login data', resp);
            $scope.getUserData();
            $scope.showAlert('Logging in!');
            $timeout(function ()
            {
              $window.location.reload(true);
            }, 2000);
          });
        }
      else
        {
          $scope.showAlert('Invalid Login!');
        }
    };

  $scope.doRegister = function ()
    {
      console.log('Doing Register', $scope.loginData);

      Personalize.personalizeRegister($scope.loginData).then(function (data)
      {
        $log.info('register data', data);
        $scope.doLogin();
        $scope.showAlert(resp);
      });
      $timeout(function ()
      {
        $scope.closeRegister();
        $scope.doLogin();
      }, 4000);
    };

  $scope.doRecovery = function ()
    {
      console.log('Doing Recovery', $scope.loginData);

      Personalize.personalizeRecovery($scope.loginData).then(function (resp)
      {
        $log.info('recovery response', resp);
        $scope.showAlert(resp);
      });

      $timeout(function ()
      {
        $scope.closeRecovery();
      }, 4000);
    };
});
con.controller('SplashController',
  function ($scope, $localStorage, Markets, $ionicSlideBoxDelegate, $state, $stateParams, $ionicSideMenuDelegate,
            $ionicNavBarDelegate, $ionicPlatform, $cordovaGeolocation)
  {
    var vm = this;
    $scope.userData = $localStorage;
    var currentPlatform = ionic.Platform.platform();
    $scope.slideIndex = 0;

    //console.log('current platform', currentPlatform);
    if (currentPlatform)
      {
        vm.device = (currentPlatform == 'android') ? 'android' : 'iphone';
        //vm.device = 'android';
      }
    else
      {
        vm.device = 'android';
      }

    if ($scope.userData.splashComplete)
      {
        $state.go('app.defaultMarket');
        //$ionicNavBarDelegate.showBar(true);
        //$ionicSideMenuDelegate.canDragContent(true);
      }
    //$ionicNavBarDelegate.showBar(false);

    $ionicSideMenuDelegate.canDragContent(false);

    //console.log('userGeoLocation', $scope.userGeoLocation);

    $scope.slides = [
      {
        top: 'Welcome To The GeoTraffic Network',
        img: './img/splash/splash.png',
        skip: 'Skip Tutorial?'
      }, {
        top: 'Your On Demand Traffic',
        img: './img/splash/full.png'
      }, {
        top: 'Hands & Eyes Free With Auto Play Feature!',
        img: './img/splash/settings.png'
      }, {
        top: 'Choose Congestion Levels That Matter To You',
        img: './img/splash/settings_severity.png'
      }, {
        top: "It's Personal. Wherever And Whenever You Want.",
        img: './img/splash/my_report.png'
      }, {
        top: 'Save Your Personalized Features Across Devices. (Optional)',
        img: './img/splash/login.png'
      }, {
        top: 'View A Traffic Map Of The Area',
        img: './img/splash/map.png'
      }
    ];

    $scope.useApp = function ()
      {
        //console.log('useApp mid', $scope.userData.marketId);
        if (!$scope.userData.marketId)
          {
            $scope.userData.splashComplete = true;
            $state.go('app.markets');
          }
        else
          {
            $scope.userData.splashComplete = true;
            $state.go('app.defaultMarket');
          }
      };

    // Called each time the slide changes
    vm.slideChanged = function (index)
      {
        //console.log('fired', index);
        $scope.slideIndex = index;
      };

  });

con.controller('MainController',
  function ($scope, $sce, $log, $ionicLoading, Markets, $ionicSideMenuDelegate, $state, $localStorage, geoAPI)
  {
    $ionicSideMenuDelegate.canDragContent(true);

    var vm = this;
    vm.version = geoAPI.version;
    vm.title = $state.params.title;
    vm.userData = $localStorage;
    vm.newFeatures = [
      {msg: 'Added Map to Markets'},
      {msg: 'Added My Report Auto Play feature'},
      {msg: 'Fixed setting for disabled location'},
      {msg: 'Minor UI Improvements'},
      {msg: 'Bug Fixes'}
    ];

    vm.selectDefaultMarket = function (mid)
      {
        if (!vm.userData.marketId)
          vm.userData.marketId = mid;
      };

    $scope.goToTutorial = function ()
      {
        vm.userData.splashComplete = false;
        $state.go('app.splash');
      };

    Markets.getAllMarkets().then(function (data)
    {
      vm.markets = data.results;
    });
  });

con.controller('SelectedRouteController', function ($scope, Markets, $localStorage, $stateParams, $log)
{
  var vm = this;
  vm.marketData = $stateParams;

});

con.controller('RouteController',
  function ($rootScope, $scope, $sce, $log, $ionicLoading, $stateParams, $cordovaMedia, $localStorage, Markets,
            $ionicPlatform, $window, $state, $ionicSideMenuDelegate, AudioService, $ionicSlideBoxDelegate,
            $ionicHistory, NgMap, $interval,$timeout)
  {
    //$ionicHistory.nextViewOptions({
    //  disableBack: true,
    //  historyRoot: true
    //});
    //($ionicHistory) ? console.log('history', $ionicHistory.viewHistory()) : console.log('none');

    var vm = this;
    $scope.title = $stateParams.title;
    $scope.$state = $state;
    vm.mid = $stateParams.marketId;
    vm.showAllEnabled = false;
    $scope.autoPlayCounter = 0;
    $scope.userData = $localStorage;
    $ionicLoading.show({
      template: 'loading...'

    });
    //$scope.slideIndex = 0;
    $scope.toggleMap = function ()
      {
        if ($scope.slideIndex == 0)
          {
            $ionicSlideBoxDelegate.slide(1);
            $scope.slideIndex = 1;
          }
        else
          {
            $ionicSlideBoxDelegate.slide(0);
            $scope.slideIndex = 0;
          }
      };
    //Media service test
    vm.media = AudioService;
    //Autoplay my report on first load/entry
    $scope.$on('$ionicView.enter', function ()
    {
      if ($state.current.name == 'app.defaultMarket')
        {
          if (vm.media.media == null && $scope.userData.autoPlayEnable && $scope.userData.myReportList
            && $scope.autoPlayCounter < 1)
            {
              $scope.playReport($scope.userData.myReport);
              $scope.selectedIndex = 0;
              $scope.autoPlayCounter++;
            }
        }
    });

    $ionicSideMenuDelegate.canDragContent(true);
    $scope.showSideMenu = true;

    $scope.showMap = function (rId)
      {
        $state.go('app.selectedRoute', {'marketId': vm.mid, 'rId': rId});
      };

    vm.getBgColor = function (singleCase)
      {
        var severityColor = {
          1: 'severity-green',
          2: 'severity-yellow',
          3: 'severity-red',
          4: 'severity-black'
        };

        return severityColor[singleCase];
      };
    $scope.toggleShowAllRoutes = function ()
      {
        (!vm.showAllEnabled) ? vm.showAllEnabled = true : vm.showAllEnabled = false;
      };
    $scope.setDefaultMarket = function ()
      {
        $scope.userData.marketId = vm.mid;
      };

    $scope.myReportObj = {
      artifact: {
        description: "Personal Report",
        latitude: "",
        longitude: "",
        name: "My Report",
        roadCondition: "5",
        type: "OneRoad",
        uniqueId: "myReport_0"
      },
      combinedPlaylist: $scope.userData.myReport,
      playlist: [
        {
          ad: "false",
          mp3: $scope.userData.myReport,
          type: "user_report"
        }
      ],
      images: {
        img_80: './img/user_icon_2.png',
        img_150: './img/user_icon_2.png',
        img_300: './img/user_icon_2.png',
        img_500: './img/user_icon_2.png',
        svg: './img/user_icon_2.png'
      }
    };

    (function doRefresh()
      {

        Markets.getMarket(vm.mid).then(function (data)
        {
          vm.marketData = {
            title: data.results.market.name,
            status: data.results.market.status,
            updateTime: new Date(),
            lat: parseFloat(data.results.market.latitude),
            lon: parseFloat(data.results.market.longitude)
          };
          vm.myLatlng = new google.maps.LatLng(vm.marketData.lat, vm.marketData.lon);
          //console.log('market data', vm.marketData);
          //NgMap.getGeoLocation().then(function (resp)
          //{
          //  console.log('Location Data',resp);
          //});
          var options = {
            id: 'gmap',
            timeout: 1500
          };
          NgMap.getMap(options).then(function (map)
          {
            if (!$scope.userData.currentLocation)
              {
                map.setCenter(vm.myLatlng);
              }
          });

          //$scope.title = data.results.market.name;
          vm.routes = data.results.reports;

          if ($scope.userData.enablePersonalization &&
            ($scope.userData.myReport && $scope.userData.myReportList)
            && $state.current.name == 'app.defaultMarket')
            {
              vm.routes.unshift($scope.myReportObj);
            }
          $ionicLoading.hide();

          $timeout(function ()
          {
            doRefresh();
            //$scope.$apply();
          }, 300000);
        });
      })();

    vm.doRefresh = function ()
      {
        Markets.getMarket(vm.mid).then(function (data)
        {
          $ionicLoading.hide();
          vm.title = data.results.market.name;
          vm.routes = data.results.reports;
          //$log.info('routes', vm.routes);
        });
        $scope.$broadcast('scroll.refreshComplete');
      };

    $scope.goBack = function ()
      {
        $ionicHistory.goBack();
      };

    $scope.noRoutesAvailable = function ()
      {
        var parent = angular.element(document.getElementById('button_icons'));
        if (parent.children().length == 0)
          {
            return true;
          } else return false;
        //$scope.noRoutesAvailable();
      };

    $scope.toggleNowPlaying = function (index, route)
      {
        //var parent = angular.element(document.getElementById('button_icons'));
        //var child = angular.element(document.getElementById('route_' + route));
        //console.log('parent', parent[0].children);
        //route = 'route_' + route;
        $scope.selectedIndex = index;
        //angular.forEach(parent[0].children, function (value, key)
        //{
        //  var child = angular.element(document.getElementById('route_' + value.id));
        //  if (route == value.id)
        //    {
        //      child.removeClass('fadeIn');
        //      child.addClass('flash infinite');
        //    }
        //  if (route != value.id)
        //    {
        //      child.removeClass('flash infinite');
        //      child.addClass('fadeIn');
        //    }
        //  console.log('route', route, 'value', value.id, (route == value.id) ? true : false);
        //});
      };

    $scope.playReport = function (track)
      {
        if (vm.media.media != null)
          {
            if (vm.media.playlist === track || $scope.userData.myReport === track)
              {
                if (vm.media.status == 2)
                  {
                    vm.media.pauseMedia();
                  }
                else
                  {
                    vm.media.playMedia();
                  }
              }
            else
              {
                vm.media.destroyMedia();
                vm.media.createMedia(track);
                vm.media.playMedia();
              }
          }
        else
          {
            vm.media.createMedia(track);
            vm.media.playMedia();
          }
        $scope.checkStatus();
      };

    var resetCurrentTrack;
    $scope.checkStatus = function ()
      {
        if (angular.isDefined(resetCurrentTrack)) return;

        resetCurrentTrack = $interval(function ()
        {
          //console.log('media status', vm.media.status);
          if (vm.media.status == 0)
            {
              $scope.selectedIndex = -1;
              $interval.cancel(resetCurrentTrack);
            }
        }, 3000);
      };

    $scope.stopChecking = function ()
      {
        if (angular.isDefined(resetCurrentTrack))
          {
            $interval.cancel(resetCurrentTrack);
            resetCurrentTrack = undefined;
          }
      };

    $scope.$on('$destroy', function ()
    {
      // Make sure that the interval is destroyed too
      $scope.stopChecking();
    });

  });

con.controller('SettingsController',
  function ($scope, $sce, $log, $ionicLoading, $stateParams, Personalize, $localStorage,
            $sessionStorage, $interval, $timeout, geoAPI, $http, Markets, $state, $ionicViewSwitcher,
            $ionicSideMenuDelegate)
  {
    //staging area
    //===========================================================
    var vm = this;
    var selectedRoutesAry = [];
    vm.title = $stateParams.title;
    $scope.userData = $localStorage;
    $scope.currentMarketId = ($scope.userData.marketId) ? $scope.userData.marketId : 241;
    $scope.userPlaylist = [];
    $scope.userPlaylistMP3 = ($scope.userData.userPlaylistMP3) ? $scope.userData.userPlaylistMP3 : null;
    $scope.routes = {};
    $scope.myReportListAry = ($scope.userData.myReportList) ? $scope.userData.myReportList.split(',') : [];
    $scope.selectedIndex = 0;
    $scope.personalizeEnable = false;
    $scope.autoPlayEnable = false;
    $scope.lowestRoadConditionEnable = false;
    $scope.defaultMarketEnable = {
      title: 'Default Market',
      checked: false
    };
    vm.severityList = [
      {
        id: 1,
        title: 'Light traffic',
        color: 'severity-green'
      },
      {
        id: 2,
        title: 'Moderate traffic',
        color: 'severity-yellow'
      },
      {
        id: 3,
        title: 'Heavy Traffic',
        color: 'severity-red'
      },
      {
        id: 4,
        title: 'Closed or Stand Still',
        color: 'severity-black'
      }
    ];

    $ionicSideMenuDelegate.canDragContent(true);

    //$log.warn('vm', vm, '\n\n userData', $scope.userData);

    //End Staging Area

    //Initial load
    //===========================================================
    //===========================================================


    //get all markets
    Markets.getAllMarkets().then(function (data)
    {
      $scope.markets = data.results;
      //$log.info('markets', $scope.markets);
    });

    //get specific market
    Markets.getMarket($scope.currentMarketId).then(function (data)
    {
      $scope.routes = data.results;
      //$log.info('routes', $scope.routes);
    });

    //End Initial Load

    //If user data exists -> load it
    //===========================================================

    (function setup()
      {
        if ($scope.userData.marketId)
          {
            $scope.defaultMarketEnable = {
              title: 'Default Market',
              checked: true
            };

            $scope.defaultMarketSelection = {marketId: $scope.userData.marketId};

          }
        else if ($scope.defaultMarketEnable.checked = false)
          {
            delete $scope.userData.marketId;
          }
        else $scope.defaultMarketEnable.checked = false;

        if ($scope.userData.enablePersonalization == true && $scope.userData.myReportList)
          {
            $scope.personalizeEnable = true;
            if ($scope.userData.autoPlayEnable == true)
              {
                $scope.autoPlayEnable = true;

              }
          }

        if ($scope.userData.lowestRoadCondition)
          {
            $scope.lowestRoadConditionEnable = true;
            $scope.lowestRoadConditionSelection = {id: $scope.userData.lowestRoadCondition};
          }

        if ($scope.userData.myReportList)
          {
            setMyReport();
          }
      })();


    function setMyReport()
      {
        $scope.userData.myReportMId = $scope.currentMarketId;
        $scope.userData.myReport = geoAPI.apiEndpoint +
          '/streamPlaylist/' +
          geoAPI.partnerId +
          '/' +
          $scope.currentMarketId +
          '/';
        angular.forEach($scope.myReportListAry, function (value, key)
        {
          var parent = angular.element(document.getElementById(value));
          var child = angular.element(document.getElementById('sel-' + value));
          var grandchild = angular.element(document.getElementById('sel_' + value));
          var index = selectedRoutesAry.indexOf(value);
          //selectedRoutesAry.push(value);

          if (index)
            {
              $scope.userData.myReport += value + ',';
            }

          //$scope.selectedIndex = ($scope.selectedIndex == 0) ? 1 : $scope.myReportListAry.length;
        });

        $scope.userData.myReport = $scope.userData.myReport.slice(0, -1);


        $timeout(function ()
        {
          //console.log('timeout setter');
          angular.forEach($scope.myReportListAry, function (value, key)
          {
            var parent = angular.element(document.getElementById(value));
            var child = angular.element(document.getElementById('sel-' + value));
            var grandchild = angular.element(document.getElementById('sel_' + value));
            var index = selectedRoutesAry.indexOf(value);

            if (index)
              {
                selectedRoutesAry.push(value);
                child.append('<p id="sel_' + value + '" class="routeBadge animated rubberBand" >' + (key + 1) + '</p>');
              }
            $scope.selectedIndex = selectedRoutesAry.length;
            //console.log('index', $scope.selectedIndex);

          });
        }, 2500);

        //angular.forEach(selectedRoutesAry, function (value, key)
        //{
        //  if (routeId == value)
        //    {
        //      parent.addClass('selectedRoute').addClass('shadow');
        //      //console.log('routeid test',routeId,'val test', value);
        //    }
        //});
      };


    //END user data setup


    //methods
    //===========================================================

    $scope.goBack = function ()
      {
        saveUserProfile();
        $timeout(function ()
        {
          $ionicViewSwitcher.nextDirection('back');
          ($scope.userData.marketId) ? $state.go('app.defaultMarket', {marketId: $scope.userData.marketId}) :
            $state.go('app.markets');
        }, 600);
      };

    $scope.togglePersonalRoute = function ()
      {
        if ($scope.personalizeEnable == false)
          {
            $scope.personalizeEnable = true;
            $scope.userData.enablePersonalization = true;
            ($scope.userData.myReport) ? setMyReport() : console.info('No Report Set');
          }
        else
          {
            $scope.personalizeEnable = false;
            $scope.userData.enablePersonalization = false;
            $scope.userData.autoPlayEnable = false;
            delete $scope.userData.myReportMId;
            delete $scope.userData.myReport;
            delete $scope.userData.myReportList;
          }
        //console.log('testToggle changed to ' + $scope.personalizeEnable, $scope.userData.enablePersonalization);
      };
    $scope.toggleAutoPlay = function ()
      {
        //console.log('self',self);
        if ($scope.autoPlayEnable == false)
          {
            $scope.autoPlayEnable = true;
            $scope.userData.autoPlayEnable = true;
          }
        else
          {
            $scope.autoPlayEnable = false;
            $scope.userData.autoPlayEnable = false;
          }

        //($scope.autoPlayEnable) ? $scope.userData.autoPlayEnable = false : $scope.userData.autoPlayEnable = true;
      };
    $scope.toggleDefaultMarket = function ()
      {
        if ($scope.defaultMarketEnable.checked == false)
          {
            $scope.defaultMarketEnable.checked = true;
            $scope.userData.enableDefaultMarket = true;
          }
        else
          {
            $scope.defaultMarketEnable.checked = false;
            $scope.userData.enableDefaultMarket = false;
          }
        //console.log('testToggle changed to ' + $scope.personalizeEnable, $scope.userData.enablePersonalization);
      };

    $scope.toggleLowestRoadConditionEnable = function ()
      {
        if ($scope.lowestRoadConditionEnable == false)
          {
            $scope.lowestRoadConditionEnable = true;
            $scope.userData.lowestRoadConditionEnable = true;
            $scope.lowestRoadConditionSelection = {id: $scope.userData.lowestRoadCondition};
          }
        else
          {
            $scope.lowestRoadConditionEnable = false;
            $scope.userData.lowestRoadConditionEnable = false;
            delete $scope.userData.lowestRoadCondition;
          }
        //console.log('testToggle changed to ' + $scope.lowestRoadConditionEnable, $scope.userData.lowestRoadConditionEnable);
      };

    $scope.setSeverityDefault = function (selected)
      {
        $scope.userData.lowestRoadCondition = selected.id;
      };

    $scope.submitMId = function (selected)
      {
        $scope.userData.marketId = selected.marketId;
        $scope.currentMarketId = selected.marketId;
        //$log.info('selected mid', selected, 'userData', $scope.userData);
        vm.doRefresh();
      };

    vm.doRefresh = function ()
      {
        Markets.getMarket($scope.currentMarketId).then(function (data)
        {
          $scope.routes = data.results;

        });
        $scope.$broadcast('scroll.refreshComplete');
      };

    $scope.removePersonalReport = function ()
      {
        delete $scope.userData.enablePersonalization;
        delete $scope.userData.myReport;
        delete $scope.userData.myReportList;
      };

    $scope.selectedRoutes = function ($index, routeId)
      {
        var parent = angular.element(document.getElementById('button_icons'));
        var child = angular.element(document.getElementById('sel-' + routeId));
        var grandchild = angular.element(document.getElementById('sel_' + routeId));
        child.toggleClass('selectedRoute').toggleClass('shadow');
        //$log.info('index==', $index, 'route Id==', routeId,'parent',parent[0].children);
        //$log.warn('routes array', selectedRoutesAry.indexOf(routeId));
        var index = selectedRoutesAry.indexOf(routeId);
        if (index == -1)
          {
            selectedRoutesAry.push(routeId);
            $scope.selectedIndex = ($scope.selectedIndex == 0) ? 1 : selectedRoutesAry.length;
            child.append(
              '<p id="sel_' + routeId + '" class="routeBadge animated rubberBand" >' + $scope.selectedIndex + '</p>');
            //$scope.selectedIndex = selectedRoutesAry.length;
            //$log.info('routes id array after add', selectedRoutesAry);
          }
        else
          {
            selectedRoutesAry.splice(index, 1);
            grandchild.remove();
            //$log.warn(current.children());
            $scope.selectedIndex = selectedRoutesAry.length;
            //$log.info('routes id array after removal', selectedRoutesAry);
            //angular.forEach(selectedRoutesAry, function (value, key)
            //{
            //  selectedRoutesAry.push(value);
            //});
          }

        //angular.forEach(parent[0].children, function (value, key)
        //{
        //  if (routeId == value.id)
        //    {
        //      console.log('children', child.children())
        //    }
        //  console.log('route', routeId, 'value', value.id, (routeId == value.id) ? true : false);
        //});

      };

    $scope.setUserData = function ()
      {
        Personalize.syncUserData($scope.userData).then(function (resp)
        {
          $log.info('Data Sync', resp);
        })
      };

    $scope.getUserData = function ()
      {
        Personalize.getUserData($scope.userData).then(function (resp)
        {
          $scope.userData.uId = resp[0].id;
          $log.info('resp', resp[0]);
        })
      };

    $scope.setPersonalReport = function ($index, routeId)
      {
        $ionicLoading.show({template: 'Saving...'});
        $scope.userData.enablePersonalization = true;

        $scope.userData.myReportMId = $scope.currentMarketId;
        $scope.userData.myReport = geoAPI.apiEndpoint +
          '/streamPlaylist/' +
          geoAPI.partnerId +
          '/' +
          $scope.currentMarketId +
          '/';

        angular.forEach(selectedRoutesAry, function (value, key)
        {
          if (key < selectedRoutesAry.length - 1)
            {
              $scope.userData.myReport += value + ',';
              $scope.userData.myReportList = selectedRoutesAry.toString();
            }
          else
            {
              $scope.userData.myReport += value;
            }
        });

        //$log.info('index', $index, 'route Id==', routeId, 'myReport', $scope.userData.myReport);

        $timeout(function ()
        {
          $ionicLoading.hide();
        }, 1000);

      };

    function saveUserProfile()
      {

        $ionicLoading.show({template: 'Saving...'});

        if ($scope.personalizeEnable)
          {
            $scope.userData.enablePersonalization = true;

            $scope.userData.myReportMId = $scope.currentMarketId;
            $scope.userData.myReport = geoAPI.apiEndpoint +
              '/streamPlaylist/' +
              geoAPI.partnerId +
              '/' +
              $scope.currentMarketId +
              '/';

            angular.forEach(selectedRoutesAry, function (value, key)
            {
              if (key < selectedRoutesAry.length - 1)
                {
                  $scope.userData.myReport += value + ',';
                  $scope.userData.myReportList = selectedRoutesAry.toString();
                }
              else
                {
                  $scope.userData.myReport += value;
                }
            });
          }

        $timeout(function ()
        {
          $ionicLoading.hide();
        }, 500);

        if ($scope.userData.isAuthenticated)
          {
            Personalize.syncUserData($scope.userData).then(function (resp)
            {
              $log.info('Data Saved!');
            });

            //TODO: Remove this for prod
            //$timeout(function ()
            //{
            //  $scope.getUserData();
            //}, 2000);
          }

      };

  });
