angular.module('geoLokiDB.factories', [])
  .factory('UserStorageService', [
    '$q', 'Loki', function ($q, Loki)
      {
        var _db;
        var _users;

        return {
          initDB: function ()
            {
              var adapter = new LokiCordovaFSAdapter({"prefix": "loki"});
              _db = new Loki('usersDB',
                {
                  autosave: true,
                  autosaveInterval: 1000, // 1 second
                  adapter: adapter
                });
            },
          getAllUsers: function ()
            {
              return $q(function (resolve, reject)
              {
                var options = {};

                _db.loadDatabase(options, function ()
                {
                  _users = _db.getCollection('users');

                  if (!_users)
                    {
                      _users = _db.addCollection('users');
                    }

                  resolve(_users.data);
                });
              });
            },
          addUser: function (user)
            {
              console.log('adduser user', user);
              _users.insert(user);
            },
          updateUser: function (user)
            {
              _users.update(user);
            },
          deleteUser: function (user)
            {
              _users.remove(user);
            }
        };
      }
  ]);
