var agent = navigator.userAgent;
var dev_browser = navigator.appName;
//var dev_protocol = (navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/android/i))  ? 'http' : location.protocol;
var protocol_const = 'https:';

//Development settings
var dev = angular.module('geotraffic.development', []);
dev.constant('geoAPI', {
  'version': '3.7.19',
  'partnerId': 'fmessina',
  'defaultMarketId': '241',
  'whiteLabel': 'GeoTraffic Network',
  'protocol': protocol_const,
  'personalizationEndpoint': protocol_const + '//personalize.geotraffic.com',
  'apiEndpoint': protocol_const + '//developer.geotraffic.com/api/v2',
  'roadSpeedEndpoint': protocol_const + '//roadspeed.geotraffic.com/app/v2/getRoadSpeedData/',
  'findMarketEndpoint': protocol_const + 'developer.geotraffic.com/api/findmarket/'
});

//Production settings
var prod = angular.module('geotraffic.production', []);
prod.constant('geoAPI', {
  'version': '3.7.19',
  'partnerId': 'mobilegeotraffic',
  'defaultMarketId': '241',
  'whiteLabel': 'GeoTraffic Network',
  'protocol': protocol_const,
  'personalizationEndpoint': protocol_const + '//personalize.geotraffic.com',
  'apiEndpoint': protocol_const + '//developer.geotraffic.com/api/v2',
  'rsEndpoint': protocol_const + '//roadspeed.geotraffic.com/app/v2/getRoadSpeedData/',
  'findMarketEndpoint': protocol_const + 'developer.geotraffic.com/api/findmarket/'
});

var geo = angular.module('geotraffic.services', []);

//GeoTraffic Markets API
geo.factory('Markets', [
  'geoAPI', '$http', '$q', '$cordovaGeolocation', function (geoAPI, $http, $q)
    {
      return {
        //grab all markets
        getAllMarkets: function ()
          {
            var deferred = $q.defer();
            $http.get(geoAPI.apiEndpoint + '/markets/' + geoAPI.partnerId)
              .success(deferred.resolve)
              .error(deferred.resolve);
            return deferred.promise;
          },

        //Grab market data
        getMarket: function (mId)
          {
            (!mId) ? mId = '241' : mId;
            var deferred = $q.defer();
            $http.get(geoAPI.apiEndpoint + '/markets/' + geoAPI.partnerId + '/' + mId)
              .success(deferred.resolve)
              .error(deferred.resolve);
            return deferred.promise;
          },
        //get user location, if location services are off, default mid to 241
        //currently not working due to a cordova issue
        getUserLocation: function ()
          {
            var deferred = $q.defer();

            //$cordovaGeolocation.getCurrentPosition(showPosition);


            navigator.geolocation.getCurrentPosition(showPosition);
            function showPosition(position)
              {
                var lat = position.coords.latitude;
                var lng = position.coords.longitude;
                $http.get("https://developer.geotraffic.com/api/findmarket/" + lat + "/" + lng)
                  //.then(deferred.resolve);
                  .success(deferred.resolve)
                  .error(deferred.resolve);
                //$http({
                //  method: 'get',
                //  crossDomain: true,
                //  url: "http://developer.geotraffic.com/api/findmarket/" + lat + "/" + lng,
                //  contentType: 'application/json;charset=UTF-8',
                //  dataType: 'text'
                //})
                //  .success(function (resp)
                //  {
                //    console.info('location found', resp);
                //    $scope.userData.testMid = resp;
                //  })
                //  .error(function (resp)
                //  {
                //    console.warn('location not found', resp);
                //  });
              }

            return deferred.promise;

          }

      }
    }
]);
//GeoTraffic Personalize API
geo.factory('Personalize', [
  '$http', '$q', 'geoAPI', '$resource', function ($http, $q, geoAPI)
    {
      return {
        personalizeLogin: function (obj)
          {
            var deferred = $q.defer();
            $http({
              method: 'post',
              crossDomain: true,
              url: geoAPI.personalizationEndpoint + '/api/authenticate?username=' + obj.username + '&password='
              + obj.password,
              contentType: 'application/json;charset=UTF-8',
              data: obj,
              dataType: 'json'
            })
              .success(deferred.resolve)
              .error(function (resp)
              {
                console.log('deferred', deferred.resolve, 'resp', resp);

              });
            return deferred.promise;
          },

        //Sync data
        getUserData: function (obj)
          {
            var deferred = $q.defer();

            //TODO: Fix mid injection system
            var mId = (obj.marketId) ? obj.marketId : '241';
            $http({
              method: 'GET',
              crossDomain: true,
              url: geoAPI.personalizationEndpoint + "/api/userProfiles/marketId/" + mId,
              contentType: 'application/json;charset=UTF-8',
              params: {'x-auth-token': obj.token},
              dataType: 'json'
            })
              .success(deferred.resolve)
              .error(function (resp)
              {
                console.log('resp', resp);
              });
            return deferred.promise;
          },

        //Update Personalized profile
        syncUserData: function (obj)
          {
            var deferred = $q.defer();

            //return $http.put(personalizationEndpoint+ "/api/userProfiles?x-auth-token=" + token);
            $http({
              method: 'PUT',
              url: geoAPI.personalizationEndpoint + '/api/userProfiles?x-auth-token=' + obj.token,
              contentType: "application/json;charset=UTF-8",
              data: {
                'id': obj.uId,
                'roadList': obj.myReportList,
                'marketId': obj.marketId,
                'lowestRoadCondition': obj.lowestRoadCondition
              },
              //data: '{"id": "' + obj.uId + '","roadList": "' + obj.myReportList + '","marketId": "' + obj.marketid + '"}',
              dataType: 'json'
            })
              .success(deferred.resolve)
              .error(deferred.resolve);
            return deferred.promise;
          },

        personalizeUpdateProfile2: function (obj, token, mId)
          {
            var deferred = $q.defer();

            //return $http.put(personalizationEndpoint+ "/api/userProfiles?x-auth-token=" + token);
            $http({
              method: 'PUT',
              url: geoAPI.personalizationEndpoint + '/api/userProfiles?x-auth-token=' + token,
              contentType: "application/json;charset=UTF-8",
              data: '{"id": "' + obj.profileId + '","roadList": "' + obj.roadListStr + '","marketId": "' + mId + '"}',
              dataType: 'json'
            })
              .success(deferred.resolve)
              .error(deferred.resolve);
            return deferred.promise;
          },

        //register new personalization profile
        personalizeRegister: function (obj)
          {
            var deferred = $q.defer();

            $http({
              method: 'POST',
              url: geoAPI.personalizationEndpoint + '/api/register',
              contentType: 'application/json;charset=UTF-8',
              data: obj,
              dataType: 'json'
            })
              .success(deferred.resolve)
              .error(deferred.resolve);
            return deferred.promise;
          },

        //recover current password

        personalizeRecovery: function (obj)
          {
            var deferred = $q.defer();

            $http({
              method: 'POST',
              url: geoAPI.personalizationEndpoint + '/api/account/reset_password/init',
              contentType: 'application/json;charset=UTF-8',
              data: obj.username,
              dataType: 'json'
            })
              .success(deferred.resolve)
              .error(deferred.resolve);
            return deferred.promise;
          }
      }
    }
]);

//TODO -- abstracting geo API call
geo.service('MarketsService', [
  'Markets',
  '$cordovaGeolocation',
  '$ionicPopup',
  '$q',
  '$http',
  function (Markets, $cordovaGeolocation, $ionicPopup, $q, $http)
    {
      var self = {
        'page': 1,
        'isLoading': false,
        'hasMore': true,
        'results': [],
        'lat': 39.978048,
        'lon': -75.412078,
        'refresh': function ()
          {
            self.page = 1;
            self.isLoading = false;
            self.hasMore = true;
            self.results = [];
            return self.load();
          },
        'next': function ()
          {
            self.page += 1;
            return self.load();
          },
        'load': function ()
          {
            self.isLoading = true;
            var deferred = $q.defer();

            $ionicPlatform.ready(function ()
            {
              $cordovaGeolocation.getCurrentPosition({timeout: 10000}).then(function (position)
              {
                self.lat = position.coords.latitude;
                self.lon = position.coords.longitude;

                var params = {
                  page: self.page,
                  lat: self.lat,
                  lon: self.lon
                };

                $http.get('https://codecraftpro.com/api/samples/v1/coffee/', {params: params})
                  .success(function (data)
                  {
                    self.isLoading = false;
                    console.log(data);

                    if (data.businesses.length == 0)
                      {
                        self.hasMore = false;
                      } else
                      {
                        angular.forEach(data.businesses, function (business)
                        {
                          self.results.push(business);
                        });
                      }

                    deferred.resolve();
                  })
                  .error(function (data, status, headers, config)
                  {
                    self.isLoading = false;
                    deferred.reject(data);
                  });

                return deferred.promise;
              }, function (err)
              {
                $ionicPopup.alert({
                  'title': 'Please Switch On Location Services',
                  'template': 'It seems like you switched off geolocation, please enable it.'
                });
                console.error('error', err);
              });


            });

          }


      };

      self.load();

      return self;
    }
]);
geo.service('PersonalizeService', [
  'Personalize', function (Personalize)
    {

    }
]);

geo.service('AudioService', [
  '$window',
  '$cordovaMedia',
  function ($window, $cordovaMedia)
    {
      if($window.cordova)
        {
          cordova.plugins.backgroundMode.enable();
        }
      var self = {
        media: null,
        playlist: null,
        playlistLength: 0,
        playlistIndex: 0,
        status: 0,//0 = null, 1= loaded, 2 = playing, 3 = paused
        createMedia: function (track)
          {
            if (typeof track === 'string')
              {
                if ($window.cordova)
                  {
                    //self.media = new Media(track, getNext());
                    self.media = new $window.Audio(track);
                  }
                else
                  {
                    self.media = new Audio(track);
                  }
              }
            else
              {
                if (self.playlist !== track)
                  {
                    self.playlistIndex = 0;
                  }
                self.playlist = track;
                self.playlistLength = track.length;
                self.media = new Audio(track[0].mp3);

                self.media.load();
              }
            self.status = 1;
          },
        playMedia: function ()
          {
            if (self.status === 1)
              {
                self.status = 2;
                self.media.play();

                if (self.playlist)
                  {
                    self.media.addEventListener("ended", function ()
                    {
                      getNext();
                    }, false);
                  }
              }
            else
              {
                self.status = 2;
                self.media.play();
              }

          },
        pauseMedia: function ()
          {
            self.status = 3;
            self.media.pause();
          },
        destroyMedia: function ()
          {
            self.media.pause();
            self.media = null;
            self.status = 0;
            self.playlistIndex = 0;
          }
      };//END SELF

      function getNext()
        {
          self.playlistIndex++;
          if (self.playlistIndex < self.playlistLength)
            {
              self.createMedia(self.playlist[self.playlistIndex].mp3);
              self.status = 1;
              self.playMedia();
            }
          else
            {
              self.destroyMedia();
            }
        }


      return self;
    }
]);
//GeoTraffic Route Directives
geo.directive('routeDisplay', function ()
{
  return {
    restrict: 'EAC',
    templateUrl: 'templates/route.html',
    replace: false,
    scope: {
      marketObject: '='
    }
  };
});
